; TIP1174.LSP: LNX.LSP   Dimension, Count Circles and Arcs
;                         (c)1995, Brian Bennett

; Automatic counting and construction of leadered
; dimension for circles and arcs.

(defun C:LNX (/ BM SM OM DS TX P1 ENT SZ
  POS P2 P3 SIZ NN TXT DMT)
  (setq CMD (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (command ".UNDO" "M")
  (setq BM (getvar "BLIPMODE")
    SM (getvar "SNAPMODE")
    OM (getvar "ORTHOMODE")
    DS (getvar "DIMSCALE")
  TX (getvar "TEXTHGT"))
  (setvar "BLIPMODE" 0)
  (setvar "SNAPMODE" 0)
  (setvar "ORTHOMODE" 0)
  (setq P1 (entsel "\nPick circle/arc at point of leader: ")
    ENT (entget (car P1))
    SZ (cdr (assoc 40 ENT))
    POS (car (cdr P1))
    P2 (getpoint POS "\nLeader length: ")
    P3 (cdr (assoc 10 ENT))
  P2 (polar POS (angle P3 POS)(distance POS P2)))
  (if (= (cdr (assoc 0 ENT)) "CIRCLE")
    (setq SIZ (* (cdr (assoc 40 ENT)) 2.0))
  (setq SIZ (cdr (assoc 40 ENT))))
  (cond
    ((= (cdr (assoc 0 ENT)) "CIRCLE")
      (setq NN (ssget "X" (list (cons 0 "CIRCLE")(cons 40 SZ))))
      (if (> (car P2)(car POS))
        (setq TXT (strcase (strcat (itoa (sslength NN))
        (chr 120))))
        (setq TXT (strcase (strcat (itoa (sslength NN))
      (chr 120)))))
      (if (= (sslength NN) 1)(setq TXT ""))
      (setq DMT (strcase (strcat (chr 37)(chr 37)(chr 67)(rtos SIZ)))
      TXT (strcat TXT DMT))
      (command ".DIM" "LEA" POS P2 "" "" "EXIT")
      (if (>= (car P2)(car POS))
        (command ".TEXT" "ML" (polar P2 0.0 (* 0.27 DS))
        (* 0.18 DS) "" TXT)
        (command ".TEXT" "MR" (polar P2 3.141596 (* 0.27 DS))
      (* 0.18 DS) "" TXT))
    )
    ((= (cdr (assoc 0 ENT)) "ARC")
      (setq NN (ssget "X" (list (cons 0 "ARC")(cons 40 SZ))))
      (if (> (car P2)(car POS))
        (setq TXT (strcase (strcat (itoa (sslength NN))
        (chr 120))))
        (setq TXT (strcase (strcat (itoa (sslength NN))
      (chr 120)))))
      (if (= (sslength NN) 1)(setq TXT ""))
      (setq DMT (strcase (strcat (chr 82)(rtos SIZ)))
      TXT (strcat TXT DMT))
      (command ".DIM" "LEA" POS P2 "" "" "EXIT")
      (if (>= (car P2)(car POS))
        (command ".TEXT" "ML" (polar P2 0.0 (* 0.27 DS))
        (* 0.18 DS) "" TXT)
        (command ".TEXT" "MR" (polar P2 3.141596 (* 0.27 DS))
      (* 0.18 DS) "" TXT))
    )
  );end of cond
  (setvar "BLIPMODE" BM)
  (setvar "SNAPMODE" SM)
  (setvar "ORTHOMODE" OM)
  (setvar "TEXTHGT" TX)
  (setvar "CMDECHO" CMD)
  (princ)
);end of lnx.lsp
