; TIP1175A.LSP: QDIMEDIT.LSP   Quick Dimension Editor   (c)1995, Jimmy Dobbs

; A quick dimension editor that will update
; one or more selected dimensions per the dialog
; box settings for: dimscale, dimtix, dimtofl & dimtih.

(defun C:QDIMEDIT (/ TEMP-DIMTOFL TEMP-DIMTIH 
  TEMP-DIMTIX TEMP-DIMSCL A-DIM)
  (setq TEMP-DIMTOFL (getvar "dimtofl")
    TEMP-DIMTIH (getvar "dimtih")
    TEMP-DIMTIX (getvar "dimtix")
    TEMP-DIMSCL (getvar "dimscale")
    DIM-A (ssget (list (cons 0 "dimension")))
  )

  (setq dcl_id (load_dialog "qdimedit.dcl"))
  (if (not (new_dialog "qk_dim_edit" dcl_id)) (exit))

  (if (= 1 (getvar "dimtofl")) (set_tile "dimtofl-a" "1"))
  (if (= 0 (getvar "dimtih")) (set_tile "dimtih-a" "1"))
  (if (= 1 (getvar "dimtix")) (set_tile "dimtix-a" "1"))
  (set_tile "dimscl" (rtos temp-dimscl 2 4))

  (action_tile "accept" "(set_vars)(done_dialog)")
  (start_dialog)
  (unload_dialog dcl_id)

  (command "dim1" "update" dim-a "")

  (setvar "dimtofl" TEMP-DIMTOFL)
  (setvar "dimtih" TEMP-DIMTIH)
  (setvar "dimtix" TEMP-DIMTIX)
  (setvar "dimscale" TEMP-DIMSCL)

  (princ)
)

(defun set_vars ()
  (if (= "1" (get_tile "dimtofl-a")) (setvar "dimtofl" 1) (setvar "dimtofl" 0))
  (if (= "1" (get_tile "dimtih-a")) (setvar "dimtih" 0) (setvar "dimtih" 1))
  (if (= "1" (get_tile "dimtix-a")) (setvar "dimtix" 1) (setvar "dimtix" 0))
  (setvar "dimscale" (atof (get_tile "dimscl")))
)
(princ "Type Qdimedit to start command")
(princ)
;end qdimedit.lsp
