; TIP1176A.LSP: QSTAMP.LSP   Quick Stamp   (c)1995, Leonard R. Miller

; Designed for those quickie "to fit" hard copies.  It places
; sometimes omitted information where it's visible all the time.
; Vitals such as drawing name, source directory, date and time,
; plus a calculated scale reference.  QStamp will appear in upper left
; corner of drawing, poised for dragging to some unoccupied space.
; Entities are created on a unique layer so some ssget routine can easily
; find it later for automatic purging.

; My tablet macro for saving drawings is on the next 2 lines and
; illustrates the purging of qstamp entities, then save, technique.
;;; [T1-95]^C^C(setq s3 (ssget "x" '((8 . "donotuse_me"))))+
;;; (if (/= s3 nil)(command "erase" s3 ""))(command "save")

(defun C:QSTAMP (/ DAT REM DNAME DCNT HOURZ HOUR_MIN INCR 
    PATH_LGTH OPT_SZ PATH SCALE_LGTH SCALE_PT SCALE_Pt1 
    SCALE_PT2 SCALE_PT3 SCALE_PT4 SCALE_PT5 SCALE_PT6 
    THE_DATE TX1 TX2 TXT_PT VIEW_CTR VIEW_SIZE PCNT 
    DREM UNITZ)

  (setq pbx (getvar "pickbox") lyr (getvar "clayer")
    CE (getvar "cmdecho") COL (getvar "cecolor") OSN (getvar "osmode")
    SNP (getvar "snapmode") GRD (getvar "gridmode") OTO (getvar "orthomode")
    PLW (getvar "plinewid") TXE (getvar "texteval") TXS (getvar "textstyle")
    TLM (getvar "tilemode") EXP (getvar "expert") RGM (getvar "regenmode")
    APR (getvar "aperture")
  )
  (command "layer" "s" "0" "")
  (command "pickbox" "0")
  (command "color" "bylayer")
  (command "style" "stmp" "" "0" "" "" "" "" "")
  (setvar "plinewid" 0)
  (setvar "gridmode" 0)
  (setvar "expert" 1)
  (setvar "regenmode" 0)
  (setvar "snapmode" 0)
  (setvar "aperture" 1)
  (setvar "osmode" 0)
  (setvar "cmdecho" 0)
  (setvar "orthomode" 0)
  (setvar "texteval" 0)
  (setvar "tilemode" 1)
  (setq VIEW_CTR (getvar "viewctr"))
  (setq VIEW_SIZE (getvar "viewsize"))
  (setq OPT_SZ (/ VIEW_SIZE 14.0))
  (setq INCR 0.000488281)
  (while (< INCR OPT_SZ)
    (setq SCALE_LGTH INCR)
    (setq INCR (* INCR 2.0))
  );end while
  ;;;extract dwg portion only
  (setq DNAMe (dwgname8))
  (setq PATH (getvar "dwgprefix"))
  (setq TX1 (strcase (strcat "FILE NAME:  " DNAME)))
  (setq TX2 (rtos (getvar "cdate") 2 0))
  (setq THE_DATE
    (strcat
  (substr tx2 5 2)"/"(substr tx2 7 2)"/"(substr tx2 3 2)))
  (setq DAT (atof (substr (rtos (getvar "date") 2 6) 8 5)))
  (setq HOUR_MIN (* DAT 24.0))
  (setq HOURZ (fix HOUR_MIN))
  (setq MINIT (* (- HOUR_MIN HOURZ) 60.0))
  ;add leading zero if needed
  (setq MINIT (rtos MINIT 2 0))
  (if (< (strlen MINIT) 2)
    (setq MINIT (strcat "0" MINIT))
  )
  (setq TXT_PT (polar VIEW_CTR pi (/ VIEW_SIZE 2.7)))
  (setq TXT_PT (polar TXT_PT 90.0 (/ VIEW_SIZE 2.0)))
  (setq SCALE_PT TXT_PT)
  (command "layer" "m" "donotuse_me" "c" "red" "" "")
  (command "text" TXT_PT (/ view_size 100.0) 0.0 tx1)
  (command "text" "" (strcat "PRINTED: " (itoa hourz) ":"
      minit ", "
      (substr TX2 5 2) "/"
      (substr   TX2 7 2) "/"
  (substr   TX2 3 2)))
  (if (= US_MM nil)
    (setq unitz " UNITS.")
    (if(= US_MM 25.4)
      (setq unitz " MM.")
      (setq unitz " INCHES.")
    )
  )
  (command "text" "" (strcat "PATH: " path"  SCALE INCR = "
  (rtos SCALE_LGTH) UNITZ)) 
  (setq SCALE_PT1 (polar scale_pt (* pi 1.5)(/ VIEW_SIZE 23.0)))
  (setq SCALE_PT2 (polar SCALE_PT1 0.0 SCALE_LGTH))
  (setq SCALE_PT3 (polar SCALE_PT2 0.0 SCALE_LGTH))
  (setq SCALE_PT4 (polar SCALE_PT3 0.0 SCALE_LGTH))
  (setq SCALE_PT5 (polar SCALE_PT4 0.0 SCALE_LGTH))
  (setq SCALE_PT6 (polar SCALE_PT5 0.0 SCALE_LGTH))
  (command "pline" SCALE_PT1 "w" (/ vIEW_SIZE 100.0) "" SCALE_PT2 "")
  (command "pline" SCALE_PT2 "w" 0.0 "" SCALE_PT3 "")
  (command "pline" SCALE_PT3 "w" (/ vIEW_SIZE 100.0) "" SCALE_PT4 "")
  (command "pline" SCALE_PT4 "w" 0.0 "" SCALE_PT5 "")
  (command "pline" SCALE_PT5 "w" (/ vIEW_SIZE 100.0) "" SCALE_PT6 "")
  (command "pline" SCALE_PT "w" 0.0 0.0 scale_pt "")
  (command "erase" "l" "")
  (ssget "x" '((8 . "donotuse_me")))
  (command "move" "p" "" "@" pause)
  ;
  ;get prior settings.  This will allow you to leave the environment
  ; as you found it when QSTAMP is complete.
  ;
  ;restore prior settings.
  (command "layer" "s" LYR "")
  (setvar "pickbox" PBX)
  (setvar "cmdecho" CE)
  (setvar "cecolor" COL)
  (setvar "osmode" OSN)
  (setvar "snapmode" SNP)
  (setvar "gridmode" GRD)
  (setvar "orthomodE" OTO)
  (setvar "plinewid" PLW)
  (setvar "texteval" TXE)
  (setvar "textstylE" TXS)
  (setvar "tilemode" TLM)
  (setvar "expert" EXP)
  (setvar "regenmode" RGM)
  (setvar "aperture" APR)
)
;;; Fname.lsp, contributed by Mark Middlebrook, Dec 1993.
;;; and created by Tony Tanzillo

(defun fname (s)
  (if (wcmatch s "*\\*,*/*,*:*")
    (substr s (1+ (fname-aux (strlen s))))
    s
  )
)
(defun fname-aux (n)
  (cond
    (    (zerop n) 0)
    (    (member (substr s n 1) '("\\" "/" ":")) n)
  (t   (fname-aux (1- n))))
)
(defun dwgname8 ()
  (fname (getvar"dwgname"))
)
(princ);end qstamp.lsp
