; TIP1177.LSP: TCC.LSP   Text Copy or Cut   (c)1995, G. Ramesh

; Text cut or copy

(defun C:TCC()
  (setvar "cmdecho" 0)
  (initget "CUT,T COPY,C")
  (setq OPT (getkword "\nText cuT/Copy<C>: "))
  (if (or (not OPT) (= OPT "COPY")) (tcopy) (tcut))
  (prin1)
)

(defun tcopy (/ OPT P1 P2 SS SL S INSPT BLIST LL UR OLDSTR N)
  (setq OPT "No")
  (while (= OPT "No")
    (setq P1 (getpoint "\nFirst corner: "))(initget 32)
    (setq P2 (getcorner p1 "\nOther corner: ")
      SS (ssget "c" P1 P2) 
      SL (sslength SS)
    )
    (if (or (/= "TEXT" (cdr(assoc 0 (entget(ssname ss 0))))) (/= SL 1)) 
      (progn(prompt "\nInvalid selection.")(exit))
    )
    (setq EL (entget (ssname SS 0)) S (cdr(assoc 1 EL))
      INSPT (cdr(assoc 10 EL))
      BLIST (textbox EL)
      LL (mapcar '+ (car BLIST) INSPT)
      UR (mapcar '+ (cadr BLIST) INSPT)
      OLDSTR S
    )
    (if (equal (assoc 11 EL) '(11 0.0 0.0 0.0)) (setq N 10) (setq N 11))
    (cut) ; defun to get the TEXT portion
    (prompt (strcat "\nSelected TEXT portion is \"" S "\""))
    (initget "Yes No")
    (setq OPT (getkword "\nProceed with writing <Yes>? "))
    (if (not OPT) (setq OPT "Yes"))
    (if (= OPT "Yes") (write))
  ) ; while close
  (prin1)
)

(defun *error* (m)
  (prin1)
)

; TCUT - text cut 
(defun tcut(/ OPT P1 P2 SS SL EL S INSPT BLIST LL UR OLDSTR N START END)
  (command "undo" "g")
  (setq OPT "No")
  (while (= OPT "No")
    (setq P1 (getpoint "\nFirst corner: "))(initget 32)
    (setq P2 (getcorner p1 "\nOther corner: ")
      SS (ssget "c" P1 P2) 
      SL (sslength SS)
    )
    (if (or (/= "TEXT" (cdr(assoc 0 (entget(ssname SS 0))))) (/= SL 1)) 
      (progn(prompt "\nInvalid selection.")(exit))
    )
    (setq EL (entget (ssname ss 0)) 
      S (cdr(assoc 1 EL))
      INSPT (cdr(assoc 10 EL)) 
      BLIST (textbox EL)
      LL (mapcar '+ (car BLIST) INSPT) 
      UR (mapcar '+ (cadr BLIST) INSPT)
      OLDSTR S
    )
    (if (equal (assoc 11 EL) '(11 0.0 0.0 0.0)) (setq N 10) (setq N 11))
    (cut) ; defun to get the TEXT portion
    (prompt (strcat "\nText portion to be cut is \"" s "\""))
    (initget "Yes No")
    (setq OPT (getkword "\nProceed with cutting <Yes>? "))
    (if (not OPT) (setq OPT "Yes"))
    (if (and (= S OLDSTR)(= OPT "Yes")) 
      (progn (entdel(ssname SS 0)) (setq OPT nil))
    )
    (if (= OPT "Yes")
      (if (/= S OLDSTR) ; if both are same text, then erase it
        (progn
          (setq OLDSTR (strcat (substr OLDSTR 1 (1- START)) (substr OLDSTR (+ START END))))
          (entmod (subst (cons 1 OLDSTR) (assoc 1 EL) EL))
          (prin1)
        ); close progn
        (progn (entdel (ssname SS 0)) (setq OPT nil))
      )
    ); if close
  ); while close
  (command "undo" "end")(prin1)
)

(defun cut (/ X LEN DS)
  (setq X (car LL) 
    LEN (car (cadr BLIST)) 
  START 1)
  (while (and (<= x (car P1)) (/= S ""))
    (setq S (substr S 2)
      EL (subst (cons 1 s) (assoc 1 EL) EL) 
      BLIST (textbox EL)
      DS (- LEN (car (cadr BLIST)))
      X (car (polar LL 0 DS)) 
      START (1+ START)
    )
  ) ; while close
  (setq END 0)
  (while (and (<= X (car P2)) (/= S ""))
    (setq S (substr S 2)
      EL (subst (cons 1 S) (assoc 1 EL) EL) 
      BLIST (textbox EL)
      DS (- LEN (car (cadr BLIST)))
      X (car (polar ll 0 DS)) 
      END (1+ END)
    )
  ) ; while close
  (setq S (substr OLDSTR START END))
)

(defun write (/ BLIST X Y P1 P2 P3 P4 I)
  (setvar "TEXTSIZE" (cdr(assoc 40 EL)))
  (setvar "TEXTSTYLE" (cdr(assoc 7 EL)))
  (setq BLIST (textbox (list(cons 1 S)))
    X (- (car (cadr BLIST)) (caar BLIST))
    Y (- (cadr (cadr BLIST)) (cadr (car BLIST)))
    P1 (getvar "lastpoint") 
    I 5
  )
  (while (or (= I 12) (= I 5))
    (setq D (grread 1 6 1))
    (if (and P2 P3 P4) 
      (grvecs (list 260 P1 P2 P2 P3 P3 P4 P4 P1))
    )
    (setq P1 (cadr D) 
      P2 (polar P1 0 X)
      p3 (polar P2 (/ pi 2) Y) 
      p4 (polar P3 pi X)
    )
    (grvecs (list 260 P1 P2 P2 P3 P3 P4 P4 P1))
    (setq I (car D))
  )
  (grvecs (list 260 P1 P2 P2 P3 P3 P4 P4 P1))
  (setq EL1 (subst (cons 1 S) (assoc 1 EL) EL)
    EL1 (subst '(11 0.0 0.0 0.0) (assoc 11 EL1) EL1)
    EL1 (subst '(72 . 0) (assoc 72 EL1) EL1)
    EL1 (subst (append (list 10) P1) (assoc 10 EL1) EL1)
  )
  (entmake EL1)
)
(princ);end tcc.lsp
