; TIP1178.LSP: TRIANGLE.LSP   Threee Kinds of Triangles   (c)1995, Don Andrew

; Draw 3 types of triangles

(defun C:TRI ()
  (GVAR)
  (initget "Equilateral Isosceles Right")
  (setq ANS (getkword "\n(E)quilateral (I)sosceles (R)ight triangle: "))
  (cond 
    ((wcmatch ANS "Equilateral")(%E))
    ((wcmatch ANS "Isosceles")(%I))
    ((wcmatch ANS  "Right")(%R))  
  );cond
  (SVAR)
  (princ)
)
;equilateral triangle
(defun %E (/ BAS AN PT1 PT2 PT3)
  (setq BAS (getdist "\nLength of sides: ")
    AN (getstring "\nInsert at (M)idpoint of base / <left corner>:")
    AN (strcase AN)
    PT1 (getpoint "\Insertion point: ")        
  );setq
  (if (= AN "")
    (progn                                             ;left corner
      (setq PT2 (polar PT1 0 BAS) )
    );end then
    (progn                                             ;midpoint
      (setq PT1 (polar PT1 (dtr 180) (/ BAS 2))  
      PT2 (polar PT1 0 BAS) )
    );end else
  );end if
  (command "polygon" "3" "E" PT1 PT2)
);end defun
;
;isosceles triangle
;
(defun %I (/ BAS AN PT1 PT2 PT3 HT)
  (setq BAS (getdist "\nLength of base: ")
    AN  (getstring "\nInsert at (M)idpoint of base / <left corner>:")
    PT1 (getpoint "\Insertion point: ") 
  HT  (getdist "\nHeight of triangle: ") )
  (if (= AN "")
    (progn            ;left corner
      (setq PT2 (polar PT1 0 BAS) 
        PT3 (polar PT1 0 (/ BAS 2))
      PT3 (polar PT3 (dtr 90) HT) ) 
    );end then
    (progn            ;midpoint
      (setq PT2 (polar PT1 0 (/ BAS 2))
        PT3 (polar PT1 (dtr 90) HT) 
      PT1 (polar PT2 (dtr 180) BAS) )
    );end else
  );end if
  (command "pline" PT1 PT2 PT3 "C")
);end defun
;
;right triangle
;
(defun %R (/ PT1 PT2 PT3 BAS AN ANG HT HY)
  (setq BAS (getdist "\Length of base: ")
    PT1 (getpoint "\Insertion point of right angle: ")
  PT2 (polar PT1 0 BAS) )
  (setq AN 
  (getstring "\nEnter the Height or the letter A for Acute angle: "))
  (setq AN (strcase AN) 
  HT (distof AN)  )
  (if HT (setq PT3 (polar PT1 (dtr 90) HT) ) )
  (if (= AN "A")    ;acute angle
    (setq ANG (getangle "\Acute angle from base: ")
      HY (/ BAS (cos ANG)) 
      ANG (- pi ANG) 
    PT3 (polar PT2 ANG HY) )
  );end if angle
  (command "pline" PT1 PT2 PT3 "C")
)
;
(defun dtr (A)      ;degree-radian
(* pi (/ A 180.0)) )
;
(defun GVAR ()      ;gather variables
  (setq OS (getvar "osmode")
    BLP (getvar "blipmode")
    HLT (getvar "highlight")
  CE (getvar "cmdecho")  )
  (setvar "cmdecho" 0) ;set variables
  (setvar "highlight" 1)
(setvar "blipmode" 0) )
;
(defun SVAR ()        ;re-set variables
  (setvar "osmode" OS) 
  (setvar "blipmode" BLP)
  (setvar "highlight" HLT) 
  (setvar "cmdecho" CE) 
)
(princ "Type tri to start")
(princ) ;end triangle.lsp
